﻿<h2>Editar</h2>

<form id="itemForm">
    @Html.AntiForgeryToken()
    <input type="hidden" id="entidad" value="Loan" />
    <div>
        <label for="id" class="fw-bold">ID:</label>
        <span id="id" name="id" />
    </div>
    <div>
        <label for="loanDate" class="fw-bold">Loan Date:</label>
        <input type="date" id="loanDate" name="loanDate" class="form-control custom-width-input">
    </div>
    <div>
        <label for="returnDate" class="fw-bold">Return Date:</label>
        <input type="date" id="returnDate" name="returnDate" class="form-control custom-width-input">
    </div>
    <div>
        <label for="cmbUser" class="fw-bold">User:</label>
        <select id="cmbUser" class="form-select custom-width-input"></select>
    </div>
    <div>
        <label for="cmbBook" class="fw-bold">Book:</label>
        <select id="cmbBook" class="form-select custom-width-input"></select>
    </div>
    <br />
    <div>
        <button type="button" onclick="registrar()" class="btn btn-primary">Guardar</button>
        <button type="button" onclick="cancelar()" class="btn btn-secondary">Cancelar</button>
    </div>
</form>

<script src="~/js/crud/edit.js"></script>

<script>

    // Books
    var cmbBook = document.getElementById('cmbBook');
    cmbBook.innerHTML = "";

    fetch('/Book/getSimpleItems/')
        .then(response => response.json())
        .then(function (data) {
            //console.log(data);
            data.items.forEach(function (item) {
                var option = document.createElement('option');
                option.value = item.id;
                option.textContent = item.title;
                cmbBook.appendChild(option);
            });
        })
        .catch(error => console.error("Error: ", error));

    // Users
    var cmbUser = document.getElementById('cmbUser');
    cmbUser.innerHTML = "";

    fetch('/User/getSimpleItems/')
        .then(response => response.json())
        .then(function (data) {
            //console.log(data);
            data.items.forEach(function (item) {
                var option = document.createElement('option');
                option.value = item.id;
                option.textContent = item.fullName;
                cmbUser.appendChild(option);
            });
        })
        .catch(error => console.error("Error: ", error));


    function fillData(data) {
        document.getElementById("id").textContent = data.id;
        document.getElementById("loanDate").value = data.loanDate;
        document.getElementById("returnDate").value = data.returnDate;
        document.getElementById("cmbUser").value = data.user.id;
        document.getElementById("cmbBook").value = data.book.id;
    }

    function registrar() {
        // Lógica para enviar los datos del formulario al servidor
        console.log("Guardando cambios...");
        // Obtener los valores de los campos del formulario
        const id = document.getElementById("id").textContent;
        const loanDate = document.getElementById("loanDate").value;
        const returnDate = document.getElementById("returnDate").value;
        const user = document.getElementById("cmbUser").value;
        const book = document.getElementById("cmbBook").value;

        // Crear un objeto con los datos a enviar en el cuerpo de la solicitud POST
        const postData = {
            id: id,
            loanDate: loanDate,
            returnDate: returnDate,
            user: { id: user },
            book: { id: book }
        };

        guardar(postData);
    }

    cargarDatos();
</script>